/*( -w -s )*/
// Hitachi H8-300H/H8S Unassembler
// for Little endian machine

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "uas.h"

/*
typedef unsigned long  DWORD;
typedef unsigned short WORD;
typedef unsigned char  BYTE;
#define LOBYTE(w)	((BYTE) (w))
#define HIBYTE(w)	((BYTE) (((WORD) (w) >> 8) & 0xFF))
*/

#define LO_BYTE(w)	 ((int)((WORD)(w) & 0xFF))
#define HI_BYTE(w)	 ((int) (((WORD) (w) >> 8) & 0xFF))

 char  Spc[]=" ";	// a sign next table available.
 char  ZStr[]="";


// void uasPrintf(char *fmt,...);
// int fetchW(void);

typedef void FNANALIZE_T(WORD w);


typedef
struct AnalizeTable{	// ANSI Error ɂȂȂ킩Ȃ`I
	char *iname;
	union {
		void *dummyptr;		// ƏWarning 点B
		struct AnalizeTable *tbl;
		FNANALIZE_T *fn ;
	}a_next;

} ANALIZETABLE_T;


FNANALIZE_T
	s_movb,s_add,s_addx,s_cmp,s_subx,s_or,s_xor,s_and,s_mov,
	s_nop,s_stcmac,s_ldcmac,s_orc,s_xorc,s_andc,s_ldc,s_sub,
	s_bcc,s_mdxu,s_rtse,s_bsr,
	s_trapa,s_jmpsr,s_bsnct,s_bsbi,s_boxal,
	s_eepmov,s_7Cx,s_7Dx,s_7Ex,s_7Fx,s_ldmstm,
	s_ldcstc,s_mac,s_sleep,s_clrmac,s_01Cx,s_01Dx,s_tas,s_01Fx,s_inc,
	s_adds,s_daa,s_shllr,s_not,
	s_ext,s_dec,s_das,s_6A1x,s_6A3x,s_movfpe,
	s_movtpe,s_undef;
ANALIZETABLE_T
	T_x[],T_0x[],T_1x[],T_4x[],T_5x[],T_6x[],T_7x[],
	T_01x[],T_0Ax[],T_0Bx[],T_0Fx[],
	T_10x[],T_11x[],T_12x[],T_13x[],T_17x[],T_1Ax[],T_1Bx[],T_1Fx[],
	T_58x[],T_6Ax[],T_79x[],T_7Ax[]	;

// 1st nibble reference.
ANALIZETABLE_T T_x[16]={
	{Spc,T_0x},	{Spc,T_1x},	{"MOV.B",s_movb},	{"MOV.B",s_movb},
	{Spc,T_4x},	{Spc,T_5x},	{Spc,T_6x},	{Spc,T_7x},
	{"ADD",s_add},	{"ADDX",s_addx},	{"CMP",s_cmp},	{"SUBX",s_subx},
	{"OR",s_or},	{"XOR",s_xor},	{"AND",s_and},	{"MOV.B",s_movb}	};

// 2nd nibble references.
ANALIZETABLE_T T_0x[16]=
{	{"NOP",s_nop},	{Spc,T_01x},	{"ST",s_stcmac},	{"LD",s_ldcmac},
	{"ORC",s_orc},	{"XORC",s_xorc},{"ANDC",s_andc},{"LDC",s_ldc},
	{"ADD",s_add},	{"ADD",s_add},	{Spc,T_0Ax},	{Spc,T_0Bx},
	{"MOV",s_mov},	{"MOV",s_mov},	{"ADDX",s_addx},{Spc,T_0Fx}	};
ANALIZETABLE_T T_1x[16]=
{	{Spc,T_10x},	{Spc,T_11x},	{Spc,T_12x},	{Spc,T_13x},
	{"OR",s_or},	{"XOR",s_xor},	{"AND",s_and},	{Spc,T_17x},
	{"SUB",s_sub},	{"SUB",s_sub},	{Spc,T_1Ax},	{Spc,T_1Bx},
	{"CMP",s_cmp},	{"CMP",s_cmp},	{"SUBX",s_subx},{Spc,T_1Fx}	};
ANALIZETABLE_T T_4x[16]=
{	{"BRA",s_bcc},	{"BRN",s_bcc},	{"BHI",s_bcc},	{"BLS",s_bcc},
	{"BCC",s_bcc},	{"BCS",s_bcc},	{"BNE",s_bcc},	{"BEQ",s_bcc},
	{"BVC",s_bcc},	{"BVS",s_bcc},	{"BPL",s_bcc},	{"BMI",s_bcc},
	{"BGE",s_bcc},	{"BLT",s_bcc},	{"BGT",s_bcc},	{"BLE",s_bcc}	};
ANALIZETABLE_T T_5x[16]=
{	{"MULXU",s_mdxu},{"DIVXU",s_mdxu},{"MULXU",s_mdxu},{"DIVXU",s_mdxu},
	{"RTS",s_rtse},	{"BSR",s_bsr},	{"RTE",s_rtse},	{"TRAPA",s_trapa},
	{Spc,T_58x},	{"JMP",s_jmpsr},{"JMP",s_jmpsr},{"JMP",s_jmpsr},
	{"BSR",s_bsr},	{"JSR",s_jmpsr},{"JSR",s_jmpsr},{"JSR",s_jmpsr}	};
ANALIZETABLE_T T_6x[16]=
{	{"BSET",s_bsnct},{"BNOT",s_bsnct},{"BCLR",s_bsnct},{"BTST",s_bsnct},
	{"OR",s_or},	{"XOR",s_xor},	{"AND",s_and},	{"B",s_bsbi},
	{"MOV",s_mov},	{"MOV",s_mov},	{Spc,T_6Ax},	{"MOV",s_mov},
	{"MOV.B",s_movb},{"MOV",s_mov},	{"MOV.B",s_movb},	{"MOV",s_mov}	};
ANALIZETABLE_T T_7x[16]=
{	{"BSET",s_bsnct},{"BNOT",s_bsnct},{"BCLR",s_bsnct},{"BTST",s_bsnct},
	{"B",s_boxal},	{"B",s_boxal},	{"B",s_boxal},	{"B",s_boxal},
	{"MOV",s_mov},	{Spc,T_79x},	{Spc,T_7Ax},	{"EEPMOV",s_eepmov},
	{"B",s_7Cx},	{"B",s_7Dx},	{"B",s_7Ex},	{"B",s_7Fx}	};

// 3rd nibble references.
ANALIZETABLE_T T_01x[16]=
{	{"MOV",s_mov},{ZStr,s_ldmstm},	{ZStr,s_ldmstm},{ZStr,s_ldmstm},
	{ZStr,s_ldcstc},{ZStr,s_undef},	{"MAC",s_mac},	{ZStr,s_undef},
	{"SLEEP",s_sleep},{ZStr,s_undef},	{"CLRMAC",s_clrmac},{ZStr,s_undef},
	{"MULXS",s_01Cx},{"DIVXS",s_01Dx},	{"TAS",s_tas},	{ZStr,s_01Fx}	};
ANALIZETABLE_T T_0Ax[16]=
{	{"INC",s_inc},{ZStr,s_undef},{ZStr,s_undef},{ZStr,s_undef},
	{ZStr,s_undef},{ZStr,s_undef},{ZStr,s_undef},{ZStr,s_undef},
	{"ADD",s_add},	{"ADD",s_add},	{"ADD",s_add},	{"ADD",s_add},
	{"ADD",s_add},	{"ADD",s_add},	{"ADD",s_add},	{"ADD",s_add}};
ANALIZETABLE_T T_0Bx[16]=
{	{"ADDS #1",s_adds},{ZStr,s_undef},{ZStr,s_undef},{ZStr,s_undef},
	{ZStr,s_undef},{"INC",s_inc},{ZStr,s_undef},{"INC",s_inc},
	{"ADDS #2",s_adds},{"ADDS #4",s_adds},{ZStr,s_undef},{ZStr,s_undef},
	{ZStr,s_undef},	{"INC",s_inc},{ZStr,s_undef},{"INC",s_inc}	};
ANALIZETABLE_T T_0Fx[16]=
{	{"DAA",s_daa},{ZStr,s_undef},{ZStr,s_undef},{ZStr,s_undef},
	{ZStr,s_undef},{ZStr,s_undef},{ZStr,s_undef},{ZStr,s_undef},
	{"MOV",s_mov},{"MOV",s_mov},{"MOV",s_mov},{"MOV",s_mov},
	{"MOV",s_mov},{"MOV",s_mov},{"MOV",s_mov},{"MOV",s_mov}	};
ANALIZETABLE_T T_10x[16]=
{	{"SHLL",s_shllr},	{"SHLL",s_shllr},	{ZStr,s_undef},	{"SHLL",s_shllr},
	{"SHLL",s_shllr},	{"SHLL",s_shllr},	{ZStr,s_undef},	{"SHLL",s_shllr},
	{"SHAL",s_shllr},	{"SHAL",s_shllr},	{ZStr,s_undef},	{"SHAL",s_shllr},
	{"SHAL",s_shllr},	{"SHAL",s_shllr},	{ZStr,s_undef},	{"SHAL",s_shllr}};
ANALIZETABLE_T T_11x[16]=
{	{"SHLR",s_shllr},	{"SHLR",s_shllr},	{ZStr,s_undef},	{"SHLR",s_shllr},
	{"SHLR",s_shllr},	{"SHLR",s_shllr},	{ZStr,s_undef},	{"SHLR",s_shllr},
	{"SHAR",s_shllr},	{"SHAR",s_shllr},	{ZStr,s_undef},	{"SHAR",s_shllr},
	{"SHAR",s_shllr},	{"SHAR",s_shllr},	{ZStr,s_undef},	{"SHAR",s_shllr}};
ANALIZETABLE_T T_12x[16]=
{	{"ROTXL",s_shllr},	{"ROTXL",s_shllr},	{ZStr,s_undef},	{"ROTXL",s_shllr},
	{"ROTXL",s_shllr},	{"ROTXL",s_shllr},	{ZStr,s_undef},	{"ROTXL",s_shllr},
	{"ROTL",s_shllr},	{"ROTL",s_shllr},	{ZStr,s_undef},	{"ROTL",s_shllr},
	{"ROTL",s_shllr},	{"ROTL",s_shllr},	{ZStr,s_undef},	{"ROTL",s_shllr}};
ANALIZETABLE_T T_13x[16]=
{	{"ROTXR",s_shllr},	{"ROTXR",s_shllr},	{ZStr,s_undef},	{"ROTXR",s_shllr},
	{"ROTXR",s_shllr},	{"ROTXR",s_shllr},	{ZStr,s_undef},	{"ROTXR",s_shllr},
	{"ROTR",s_shllr},	{"ROTR",s_shllr},	{ZStr,s_undef},	{"ROTR",s_shllr},
	{"ROTR",s_shllr},	{"ROTR",s_shllr},	{ZStr,s_undef},	{"ROTR",s_shllr}};
ANALIZETABLE_T T_17x[16]=
{	{"NOT",s_not},	{"NOT",s_not},	{ZStr,s_undef},	{"NOT",s_not},
	{ZStr,s_undef},	{"EXTU",s_ext},{ZStr,s_undef},	{"EXTU",s_ext},
	{"NEG",s_not},	{"NEG",s_not},	{ZStr,s_undef},	{"NEG",s_not},
	{ZStr,s_undef},	{"EXTS",s_ext},{ZStr,s_undef},	{"EXTS",s_ext}};
ANALIZETABLE_T T_1Ax[16]=
{	{"DEC",s_dec},	{ZStr,s_undef},	{ZStr,s_undef},	{ZStr,s_undef},
	{ZStr,s_undef},	{ZStr,s_undef},	{ZStr,s_undef},	{ZStr,s_undef},
	{"SUB",s_sub},	{"SUB",s_sub},	{"SUB",s_sub},	{"SUB",s_sub},
	{"SUB",s_sub},	{"SUB",s_sub},	{"SUB",s_sub},	{"SUB",s_sub}};
ANALIZETABLE_T T_1Bx[16]=
{	{"SUBS #1",s_adds},{ZStr,s_undef},	{ZStr,s_undef},	{ZStr,s_undef},
	{ZStr,s_undef},	{"DEC",s_dec},	{ZStr,s_undef},	{"DEC",s_dec},
	{"SUBS #2",s_adds},{"SUBS #4",s_adds},{ZStr,s_undef},	{ZStr,s_undef},
	{ZStr,s_undef},	{"DEC",s_dec},	{ZStr,s_undef},	{"DEC",s_dec}};
ANALIZETABLE_T T_1Fx[16]=
{	{"DAS",s_daa},	{ZStr,s_undef},	{ZStr,s_undef},	{ZStr,s_undef},
	{ZStr,s_undef},	{ZStr,s_undef},	{ZStr,s_undef},	{ZStr,s_undef},
	{"CMP",s_cmp},	{"CMP",s_cmp},	{"CMP",s_cmp},	{"CMP",s_cmp},
	{"CMP",s_cmp},	{"CMP",s_cmp},	{"CMP",s_cmp},	{"CMP",s_cmp}};
ANALIZETABLE_T T_58x[16]=
{	{"BRA",s_bcc},	{"BRN",s_bcc},	{"BHI",s_bcc},	{"BLS",s_bcc},
	{"BCC",s_bcc},	{"BCS",s_bcc},	{"BNE",s_bcc},	{"BEQ",s_bcc},
	{"BVC",s_bcc},	{"BVS",s_bcc},	{"BPL",s_bcc},	{"BMI",s_bcc},
	{"BGE",s_bcc},	{"BLT",s_bcc},	{"BGT",s_bcc},	{"BLE",s_bcc}	};
ANALIZETABLE_T T_6Ax[16]=
{	{"MOV.B",s_movb},	{ZStr,s_6A1x},	{"MOV.B",s_movb},	{ZStr,s_6A3x},
	{"MOVFPE",s_movfpe},{ZStr,s_undef},	{ZStr,s_undef},	{ZStr,s_undef},
	{"MOV.B",s_movb},{ZStr,s_undef},	{"MOV.B",s_movb},{ZStr,s_undef},
	{"MOVTPE",s_movtpe},{ZStr,s_undef},	{ZStr,s_undef},	{ZStr,s_undef}};
ANALIZETABLE_T T_79x[16]=
{	{"MOV",s_mov},	{"ADD",s_add},	{"CMP",s_cmp},	{"SUB",s_sub},
	{"OR",s_or},	{"XOR",s_xor},	{"AND",s_and},	{ZStr,s_undef},
	{ZStr,s_undef},	{ZStr,s_undef},	{ZStr,s_undef},	{ZStr,s_undef},
	{ZStr,s_undef},	{ZStr,s_undef},	{ZStr,s_undef},	{ZStr,s_undef}};
ANALIZETABLE_T T_7Ax[16]=
{	{"MOV",s_mov},	{"ADD",s_add},	{"CMP",s_cmp},	{"SUB",s_sub},
	{"OR",s_or},	{"XOR",s_xor},	{"AND",s_and},	{ZStr,s_undef},
	{ZStr,s_undef},	{ZStr,s_undef},	{ZStr,s_undef},	{ZStr,s_undef},
	{ZStr,s_undef},	{ZStr,s_undef},	{ZStr,s_undef},	{ZStr,s_undef}};

void anzError(int line)
{
	printf("Error Unexpected %s:%d\n",__FILE__,line);
	exit(5);
}

#define ANZ_ERROR() anzError(__LINE__)
#ifdef NDEBUG
#define ANZ_ASSERT(p) (void(0))
#else
#define ANZ_ASSERT(p) ((p)? (void)0 : anzError(__LINE__))
#endif

int nibble(WORD w,int idx)
{
	return (int)(((w << (idx * 4) ) >> 12) & 0x0F);
}

char *regByte(int idx){
	static char regName[16][4]=
	{"R0H","R1H","R2H","R3H","R4H","R5H","R6H","R7H",
	"R0L","R1L","R2L","R3L","R4L","R5L","R6L","R7L"};
	return regName[idx & 15];
}
char *regWord(int idx){
	static char regName[16][4]=
	{"R0","R1","R2","R3","R4","R5","R6","R7",
	"E0","E1","E2","E3","E4","E5","E6","E7"};
	return regName[idx & 15];
}
char *regLong(int idx){
	static char regName[8][4]=
	{"ER0","ER1","ER2","ER3","ER4","ER5","ER6","ER7"};
	return regName[idx & 7];
}


void s_movb(WORD w)	// 2xxx 3xxx Fxxx 6Axx 6Cxx 6Exx
{
	uasPrintf(" ");
	switch(nibble(w,0))
	{
	case 2:	//	MOV.B @aa:8,Rd	a 2 rd abs
		uasPrintf("@#H\'%02X,%s",LO_BYTE(w),regByte(nibble(w,1)));
		break;
	case 3:	//	MOV.B Rs,@aa:8	a 3 rs abs
		uasPrintf("%s,@#H\'%02X",regByte(nibble(w,1)),LO_BYTE(w));
		break;
	case 0x0f:	// MOV.B #xx:8,Rd	a F rd IMM
		uasPrintf("#H\'%02X,%s",LO_BYTE(w),regByte(nibble(w,1)));
		break;
	default:
		if(HI_BYTE(w)== 0x6A)
		switch(nibble(w,2))
		{
			int wh;
		case 0:	//	MOV.B @aa:16,Rd	a 6A 0 rd abs
			uasPrintf("@#H\'%04X,%s",
				fetchW(),regByte(nibble(w,3)));
			break;
		case 2:	//	MOV.B @aa:32,Rd	a 6A 2 rd abs
			wh=fetchW();
			uasPrintf("@#H\'%04X%04X,%s",
				wh,fetchW(),regByte(nibble(w,3)));
			break;
		case 8:	//	MOV.B Rs,@aa:16	a 6A 8 rs abs
			uasPrintf("%s,@#H\'%04X",
				regByte(nibble(w,3)),fetchW());
			break;
		case 0x0A:	//	MOV.B Rs,@aa:32	a 6A A rs abs
			wh=fetchW();
			uasPrintf("%s,@#H\'%04X%04X",
				regByte(nibble(w,3)),wh,fetchW());
			break;
		default:
			ANZ_ERROR();
		}
		else if(HI_BYTE(w)== 0x6C)
		{
			if((w & 0x80)==0)	// MOV.B @ERs+,Rd	a 6C 0ers rd
				uasPrintf("@%s+,%s",
					regLong(nibble(w,2)),regByte(nibble(w,3)) );
			else	//	MOV.B Rs,@-ERd	a 6C 1erd rs
				uasPrintf("%s,@-%s",
					regByte( nibble(w,3)),regLong(nibble(w,2)) );
		}
		else if(HI_BYTE(w)== 0x6E)
		{
			if((w & 0x80)==0)	// MOV.B @(d:16,ERs),Rd	a 6E 0ers rd disp
				uasPrintf("@(#H\'%04X,%s),%s",
					fetchW(),regLong(nibble(w,2)),regByte(nibble(w,3)) );
			else	//	MOV.B Rs,@(d:16,ERd)	a 6E 1erd rs disp
				uasPrintf("%s,@(#H\'%04X,%s)",
					regByte(nibble(w,3)),fetchW(),regLong(nibble(w,2)) );
		}
		else ANZ_ERROR();
		break;
	}
}

void s_add(WORD w)
{
	switch(HI_BYTE(w))
	{
	case 0x08:	//	ADD.B Rs,Rd		a 08	rs	 rd
		uasPrintf(".B %s,%s",
			regByte(nibble(w,2)),regByte(nibble(w,3)));
		break;
	case 0x09:	//	ADD.W Rs,Rd		v 09	rs	 rd
		uasPrintf(".W %s,%s",
			regWord(nibble(w,2)),regWord(nibble(w,3)));
		break;
	case 0x0A:	//	ADD.L ERs,ERd	k 0A	1ers 0erd
		if (( w & 0x88) != 0x80)
			s_undef(w);
		else
			uasPrintf(".L %s,%s",
				regLong(nibble(w,2)),regLong(nibble(w,3)));
		break;
	case 0x79:	//	ADD.W #xx:16,Rd		v 79	1rd	IMM
		ANZ_ASSERT (nibble(w,2) == 1) ;
		uasPrintf(".W #H\'%04X,%s",
			fetchW(),regWord(nibble(w,3)));
		break;
	case 0x7A:	//	ADD.L #xx:32,ERd	k 7A	1	0erd	IMM
		ANZ_ASSERT(nibble(w,2) == 1);
		if (( w & 0x8) != 0)	s_undef(w);
		else{
			int wh=fetchW();
			uasPrintf(".L #H\'%04X%04X,%s",
				wh,fetchW(),regLong(nibble(w,3)));
		}
		break;
	default:	//	ADD.B Rs,Rd		a 08 rs rd
		ANZ_ASSERT(nibble(w,0) == 8);
		uasPrintf(".B #H\'%02X,%s",LO_BYTE(w),regByte(nibble(w,1)));
		break;
	}
}

void s_addx(WORD w)
{
	if(HI_BYTE(w)==0x0E)	//	ADDX Rs,Rd	a 0E	 rs	rd
		uasPrintf(" %s,%s",
			regByte(nibble(w,2)),regByte(nibble(w,3)));
	else{
		ANZ_ASSERT(nibble(w,0)==9);
			//	ADDX #xx:8,Rd	a	9rd	IMM
		uasPrintf(" #H\'%02X,%s",
			LO_BYTE(w),regByte(nibble(w,1)) );
	}
}

void s_subx(WORD w)
{
	if(HI_BYTE(w)==0x1E)	//	SUBX Rs,Rd	a 1E	rs rd
		uasPrintf(" %s,%s",
			regByte(nibble(w,2)),regByte(nibble(w,3)));
	else{
		ANZ_ASSERT(nibble(w,0)==0x0B);
		//	SUBX #xx:8,Rd	a	Brd IMM
		uasPrintf(" #H\'%02X,%s",
			LO_BYTE(w),regByte(nibble(w,1)) );
	}
}

void s_cmp(WORD w)
{
	switch(HI_BYTE(w))
	{
	case 0x1C:	//	CMP.B Rs,Rd		a 1C	rs rd
		uasPrintf(".B %s,%s",
			regByte(nibble(w,2)),regByte(nibble(w,3)));
		break;
	case 0x1D:	//	CMP.W Rs,Rd		v 1D	rs rd
		uasPrintf(".W %s,%s",
			regWord(nibble(w,2)),regWord(nibble(w,3)));
		break;
	case 0x1F:	//	CMP.L ERs,ERd	k 1F	1ers 0erd
		if (( w & 0x88) != 0x80)	s_undef(w);
		else
			uasPrintf(".L %s,%s",
				regLong(nibble(w,2)),regLong(nibble(w,3)));
		break;
	case 0x79:	//	CMP.W #xx:16,Rd	  v 79	 2 rd	IMM
		ANZ_ASSERT(nibble(w,2) == 2);
		uasPrintf(".W #H\'%04X,%s",
			fetchW(),regWord(nibble(w,3)));
		break;
	case 0x7A:	//	CMP.L #xx:32,ERd  k 7A	 2 0erd	  IMM
		ANZ_ASSERT(nibble(w,2) == 2);
		if (( w & 0x8) != 0)	s_undef(w);
		else{
			int wh=fetchW();
			uasPrintf(".L #H\'%04X%04X,%s",
				wh,fetchW(),regLong(nibble(w,3)));
		}
		break;
	default:	//	CMP.B #xx:8,Rd	a A rd IMM
		ANZ_ASSERT(nibble(w,0) == 0x0A);
		uasPrintf(".B #H\'%02X,%s",
			LO_BYTE(w),regByte(nibble(w,1)) );
		break;
	}
}

void s_or(WORD w)
{
	switch(HI_BYTE(w))
	{
	case 0x14:	//	OR.B Rs,Rd	a 14 rs rd
		uasPrintf(".B %s,%s",
			regByte(nibble(w,2)),regByte(nibble(w,3)));
		break;
	case 0x64:	//	OR.W Rs,Rd	v 64 rs rd
		uasPrintf(".W %s,%s",
			regWord(nibble(w,2)),regWord(nibble(w,3)));
		break;
	case 0x79:	//	OR.W #xx:16,Rd	v 79 4rd IMM
		ANZ_ASSERT(nibble(w,2) == 4);
		uasPrintf(".W #H\'%04X,%s",
			fetchW(),regWord(nibble(w,3)));
		break;
	case 0x7A:	//	OR.L #xx:32,ERd k 7A 4 0erd IMM
		ANZ_ASSERT(nibble(w,2) == 4);
		if (( w & 0x8) != 0)	s_undef(w);
		else{
			int wh=fetchW();
			uasPrintf(".L #H\'%04X%04X,%s",
				wh,fetchW(),regLong(nibble(w,3)));
		}
		break;
	default:
		if(nibble(w,0)==0x0C)	// OR.B #xx:8,Rd	a Crd IMM
			uasPrintf(".B #H\'%02X,%s",
				LO_BYTE(w),regByte(nibble(w,1)));
		else if(w==0x01F0)
		{
			w=(WORD)fetchW();
			if(HI_BYTE(w)!=0x64) ANZ_ERROR();
			if(( w & 0x88) != 0){ s_undef(0x01F0); s_undef(w); }
			//	OR.L ERs,ERd	k 01	F0	64	0ers 0erd
			else
				uasPrintf(".L %s,%s",
					regLong(nibble(w,2)),regLong(nibble(w,3)));
		}
		else ANZ_ERROR();
		break;
	}
}

void s_xor(WORD w)
{
	switch( HI_BYTE(w) )
	{
	case 0x15:	//	XOR.B Rs,Rd		   a 15  rs rd
		uasPrintf(".B %s,%s",
			regByte(nibble(w,2)),regByte(nibble(w,3)) );
		break;
	case 0x65:	//	XOR.W Rs,Rd		   v 65  rs rd
		uasPrintf(".W %s,%s",
			regWord(nibble(w,2)),regWord(nibble(w,3)) );
		break;
	case 0x79:	//	XOR.W #xx:16,Rd	   v 79  5 rd	 IMM
		ANZ_ASSERT(nibble(w,2) == 5);
		uasPrintf(".W #H\'%04X,%s",
			fetchW(),regWord(nibble(w,3)) );
		break;
	case 0x7A:	//	XOR.L #xx:32,ERd   k 7A  5 0erd  IMM
		ANZ_ASSERT(nibble(w,2) == 5);
		if (( w & 0x8) != 0)	s_undef(w);
		else{
			int wh=fetchW();
			uasPrintf(".L #H\'%04X%04X,%s",
				wh,fetchW(),regLong(nibble(w,3)) );
		}
		break;
	default:
		if(nibble(w,0)==0x0D)	// XOR.B #xx:8,Rd	a Drd IMM
			uasPrintf(".B #H\'%02X,%s",
				LO_BYTE(w),regByte(nibble(w,1)) );
		else if(w==0x01F0) //	XOR.L ERs,ERd	k 01 F0 65 0ers 0erd
		{
			w=(WORD)fetchW();
			ANZ_ASSERT( HI_BYTE(w)==0x65 );
			if(( w & 0x88) != 0){ s_undef(0x01F0); s_undef(w); }
			else
				uasPrintf(".L %s,%s",
					regLong(nibble(w,2)),regLong(nibble(w,3)) );
		}
		else ANZ_ERROR();
		break;
	}
}


void s_and(WORD w)
{
	switch(HI_BYTE(w))
	{
	case 0x16:	//	AND.B Rs,Rd		a 16 rs rd
		uasPrintf(".B %s,%s",
			regByte(nibble(w,2)),regByte(nibble(w,3)));
		break;
	case 0x66:	//	AND.W Rs,Rd		v 66 rs rd
		uasPrintf(".W %s,%s",
			regWord(nibble(w,2)),regWord(nibble(w,3)));
		break;
	case 0x79:	//	AND.W #xx:16,Rd		v 79 6 rd
		ANZ_ASSERT(nibble(w,2) == 6);
		uasPrintf(".W #H\'%04X,%s",
			fetchW(),regWord(nibble(w,3)));
		break;
	case 0x7A:	//	AND.L #xx:32,ERd	k 7A 6 0erd IMM
		ANZ_ASSERT(nibble(w,2) == 6);
		if (( w & 0x8) != 0) s_undef(w);
		else{
			int wh=fetchW();
			uasPrintf(".L #H\'%04X%04X,%s",
				wh,fetchW(),regLong(nibble(w,3)));
		}
		break;
	default:
		if(nibble(w,0)==0x0E)	// AND.B #xx:8,Rd	a Erd IMM
			uasPrintf(".B #H\'%02X,%s",
				LO_BYTE(w),regByte(nibble(w,1)));
		else if(w==0x01F0) //	AND.L ERs,ERd	k 01 F0 66 0ers 0erd
		{
			w=(WORD)fetchW();
			ANZ_ASSERT(HI_BYTE(w)==0x66);
			if(( w & 0x88) != 0){ s_undef(0x01F0); s_undef(w); }
			else
				uasPrintf(".L %s,%s",
					regLong(nibble(w,2)),regLong(nibble(w,3)));
		}
		else ANZ_ERROR();
		break;
	}
}


void s_mov(WORD w)
{
	int n2,n3;
	WORD w1;
	n2=nibble(w,2);
	n3=nibble(w,3);
	switch(HI_BYTE(w))
	{
	case 0x0C:	//	MOV.B Rs,Rd	a 0C rs rd
		uasPrintf(".B %s,%s", regByte(n2), regByte(n3) );
		break;
	case 0x0D:	//	MOV.W Rs,Rd		v 0D rs rd
		uasPrintf(".W %s,%s", regWord(n2), regWord(n3) );
		break;
	case 0x0F:	//	MOV.L ERs,ERd	k 0F 1ers 0erd
		ANZ_ASSERT((w & 0x80)!=0);
		uasPrintf(".L %s,%s", regLong(n2), regLong(n3) );
		break;
	case 0x68:
		if( (w & 0x80)==0)	//	MOV.B @ERs,Rd	a 68 0ers rd
			uasPrintf(".B @%s,%s", regLong(n2), regByte(n3) );
		else	//		MOV.B Rs,@ERd	a 68 1erd rs
			uasPrintf(".B %s,@%s", regByte(n3), regLong(n2) );
		break;
	case 0x69:
		if((w & 0x80)==0)	//	MOV.W @ERs,Rd	v 69 0ers rd
			uasPrintf(".W @%s,%s", regLong(n2), regWord(n3) );
		else	//	MOV.W Rs,@ERd	v 69 1erd rs
			uasPrintf(".W %s,@%s", regWord(n3), regLong(n2) );
		break;
	case 0x6B:
		uasPrintf(".W ");
		switch(nibble(w,2))
		{
			int wh;
		case 0:	//	MOV.W @aa:16,Rd	v 6B 0 rd abs
			uasPrintf("@#H\'%04X,%s", fetchW(), regWord(n3) );
			break;
		case 2:	//	MOV.W @aa:32,Rd	v 6B 2 rd abs
			wh=fetchW();
			uasPrintf("@#H\'%04X%04X,%s", wh, fetchW(),
				regWord(n3) );
			break;
		case 8:	//	MOV.W Rs,@aa:16	v 6B 8 rs abs
			uasPrintf("%s,@#H\'%04X",regWord(n3), fetchW() );
			break;
		case 0x0A:	//	MOV.W Rs,@aa:32	v 6B A rs abs
			wh=fetchW();
			uasPrintf("%s,@#H\'%04X%04X",
				regWord(n3), wh,fetchW());
			break;
		default:
			ANZ_ERROR();
		}
		break;
	case 0x6D:
		uasPrintf(".W ");
		if((w & 0x80)==0)	//	MOV.W @ERs+,Rd	v 6D 0ers rd
			uasPrintf("@%s+,%s", regLong(n2), regWord(n3) );
		else	//	MOV.W Rs,@-ERd	v 6D 1erd rs
			uasPrintf("%s,@-%s", regWord(n3), regLong(n2) );
		break;
	case 0x6F:
		uasPrintf(".W ");
		if((w & 0x80)==0)	//	MOV.W @(d:16,ERs),Rd	v 6F 0ers rd disp
			uasPrintf("@(#H\'%04X,%s),%s",
				fetchW(),regLong(n2), regWord(n3) );
		else	//	MOV.W Rs,@(d:16,ERd)	v 6F 1erd rs disp
			uasPrintf("%s,@(#H\'%04X,%s)",
				regWord(n3), fetchW(), regLong(n2) );
		break;
	case 0x78:
		if((w & 0x8F) != 0)s_undef(w);
		else{
			// n2=nibble(w,2);
			w1=(WORD)fetchW();
			n3=nibble(w1,3);
			switch(w1 >>4 )
			{
				int wh;
			case 0x6A2:	// MOV.B @(d:32,ERs),Rd	a 78 0ers 0 6A 2 rd disp
				wh=fetchW();
				uasPrintf(".B @(#H\'%04X%04X,%s),%s",wh,fetchW(),
					regLong(n2),regByte(n3) );
				break;
			case 0x6AA:	// MOV.B Rs,@(d:32,ERd)	a 78 0erd 0 6A A rs disp
				wh=fetchW();
				uasPrintf(".B %s,@(#H'%04X%04X,%s)",regByte(n3),
					wh,fetchW(),regLong(n2) );
				break;
			case 0x6B2:	// MOV.W @(d:32,ERs),Rd	v 78 0ers 0 6B 2 rd disp
				wh=fetchW();
				uasPrintf(".W @(#H\'%04X%04X,%s),%s",wh,fetchW(),
					regLong(n2),regWord(n3) );
				break;
			case 0x6BA:	// MOV.W Rs,@(d:32,ERd)	v 78 0erd 0 6B A rs disp
				wh=fetchW();
				uasPrintf(".W %s,@(#H\'%04X%04X,%s)", regWord(n3),
					wh,fetchW(), regLong(n2) );
				break;
			default:
				s_undef(w);s_undef(w1);
			}
		}
		break;
	case 0x79:	// MOV.W #xx:16,Rd	v 79 0 rd IMM
		ANZ_ASSERT((w & 0xF0) == 0);
		uasPrintf(".W #H\'%04X,%s",
			fetchW(),regWord(n3) );
		break;
	case 0x7A:	// MOV.L #xx:32,Rd	k 7A 0 0erd IMM
		ANZ_ASSERT((w & 0xF0) == 0);
		if ((w & 8)== 0){
			int wh=fetchW();
			uasPrintf(".L #H\'%04X%04X,%s",wh,fetchW(),
				regLong(n3) );
		}
		else s_undef(w);
		break;
	case 0x01:
		if(LO_BYTE(w)!=0){s_undef(w); break;}
		uasPrintf(".L ");
		w=(WORD)fetchW();
		n2=nibble(w,2);
		n3=nibble(w,3);
		switch(HI_BYTE(w))
		{
			int wh;
		case 0x69:
			if((w & 0x88)==0)
				// MOV.L @ERs,ERd	k 01 00 69 0ers 0erd
				uasPrintf("@%s,%s",
					regLong(n2), regLong(n3) );
			else if((w & 0x88)==0x80)
				//	MOV.L ERs,@ERd	k 01 00 69 1erd 0ers
			uasPrintf("%s,@%s",
				regLong(n3) ,regLong(n2) );
			else{ s_undef(0x0100); s_undef(w); }
			break;
		case 0x6B:
			if((w & 8) !=0){s_undef(0x0100); s_undef(w); break;}
			switch(n2)
			{
				int wh;
			case 0:	//	MOV.L @aa:16,ERd	k 01 00 6B 0 0erd abs
				uasPrintf("@#H\'%04X,%s",
					fetchW(),regLong(n3) );
				break;
			case 2:	//	MOV.L @aa:32,ERd	k 01 00 6B 2 0erd abs
				wh=fetchW();
				uasPrintf("@#H\'%04X%04X,%s",
					wh,fetchW(),regLong(n3) );
				break;
			case 8:	//	MOV.L ERs,@aa:16	k 01 00 6B 8 0ers abs
				uasPrintf("%s,@#H\'%04X",
					regLong(n3) ,fetchW());
				break;
			case 0x0A:	//	MOV.L ERs,@aa:32	k 01 00 6B A 0ers abs
				wh=fetchW();
				uasPrintf("%s,@#H\'%04X%04X",
					regLong(n3), wh,fetchW());
				break;
			default:
				s_undef(0x100);
				s_undef(w);
			}
			break;
		case 0x6D:
			switch(w & 0x88)
			{
			case 0: // MOV.L @ERs+,ERd	k 01 00 6D 0ers 0erd
				uasPrintf("@%s+,%s",
					regLong(n2),regLong(n3) );
				break;
			case 0x80: // MOV.L ERs,@-ERd	k 01 00 6D 1erd 0ers
				uasPrintf("%s,@-%s",
					regLong(n3),regLong(n2) );
				break;
			default:
				s_undef(0x100);
				s_undef(w);
			}
			break;
		case 0x6F:
			switch(w & 0x88)
			{
			case 0: // MOV.L @(d:16,ERs),ERd	k 01 00 6F 0ers 0erd disp
				uasPrintf("@(#H\'%04X,%s),%s",
					fetchW(),regLong(n2),regLong(n3));
				break;
			case 0x80: // MOV.L ERs,@(d:16,ERd)	k 01 00 6F 1erd 0ers disp
				uasPrintf("%s,@(#H\'%04X,%s)",
					regLong(n3),fetchW(),regLong(n2) );
				break;
			default:
				s_undef(0x100);
				s_undef(w);
			}
			break;
		case 0x78:
			if((w & 0x8F)!=0){s_undef(0x100);s_undef(w); break;}
			w1=(WORD)fetchW();
			if((w1 & 0xFF28)!=0x6B20){
				s_undef(0x100);s_undef(w);s_undef(w1); break;}
			n3=nibble(w1,3);
			wh=fetchW();
			if((w1 & 0x80)==0 )
				// MOV.L @(d:32,ERs),ERd	k 01 00 78 0ers 0 6B 2 0erd disp
				uasPrintf("@(#H\'%04X%04X,%s),%s",wh,fetchW(),
					regLong(n2), regLong(n3) );
			else
				// MOV.L ERs,@(d:32,ERd)	k 01 00 78 0erd 0 6B A 0ers disp
				uasPrintf("%s,@(#H\'%04X%04X,%s)",regLong(n3),
				wh,fetchW(),regLong(n2) );
			break;
		default:
			s_undef(0x100);s_undef(w);
		}
		break;
	default:
		ANZ_ERROR();
	}
}

void s_nop(WORD w){ if(w!=0)s_undef(w); }

void s_stcmac(WORD w)
{
	ANZ_ASSERT( HI_BYTE(w)==2);
	switch(nibble(w,2))
	{
	case 0:	// STC.B CCR,Rd	a 02 0 rd
		uasPrintf("C.B CCR,%s",regByte(nibble(w,3)) );
		break;
	case 1:	// STC.B EXR,Rd	a 02 1 rd
		uasPrintf("C.B EXR,%s",regByte(nibble(w,3)) );
		break;
	case 2:	// STMAC MACH,ERd	k 02 2 0ers
		if((w & 8 )!=0) s_undef(w);
		else
			uasPrintf("MAC MACH,%s",regLong(nibble(w,3)) );
		break;
	case 3:	// STMAC MACL,ERd	k 02 3 0ers
		if((w & 8 )!=0) s_undef(w);
		else
			uasPrintf("MAC MACL,%s",regLong(nibble(w,3)) );
		break;
	default:
		s_undef(w);
	}
}



void s_ldcmac(WORD w)
{
	ANZ_ASSERT(HI_BYTE(w)==3);
	switch(nibble(w,2))
	{
	case 0:	// LDC Rs,CCR	a 03 0 rs
		uasPrintf("C %s,CCR",regByte(nibble(w,3)));
		break;
	case 1:	// LDC Rs,EXR	a 03 1 rs
		uasPrintf("C %s,EXR",regByte(nibble(w,3)));
		break;
	case 2:	// LDMAC ERs,MACH	k 03 2 0ers
		if((w & 8 )!=0) s_undef(w);
		else
			uasPrintf("MAC %s,MACH",regLong(nibble(w,3)) );
		break;
	case 3:	// LDMAC ERs,MACL	k 03 3 0ers
		if((w & 8 )!=0) s_undef(w);
		else
			uasPrintf("MAC %s,MACL",regLong(nibble(w,3)) );
		break;
	default:
		s_undef(w);
	}
}

void s_orc(WORD w)
{
	ANZ_ASSERT(HI_BYTE(w)==4);	// ORC #xx:8,CCR	a 04 IMM
	uasPrintf(" #H\'%02X,CCR",LO_BYTE(w));
}

void s_xorc(WORD w)
{
	ANZ_ASSERT( HI_BYTE(w)==5 );	// XORC #xx:8,CCR	a 05 IMM
	uasPrintf(" #H\'%02X,CCR",LO_BYTE(w));
}

void s_andc(WORD w)
{
	ANZ_ASSERT(HI_BYTE(w)==6);	// ANDC #xx:8,CCR	a 06 IMM
	uasPrintf(" #H\'%02X,CCR",LO_BYTE(w));
}

void s_ldc(WORD w)
{
	ANZ_ASSERT(HI_BYTE(w)==7);	// LDC #xx:8,CCR	a 07 IMM
	uasPrintf(" #H\'%02X,CCR",LO_BYTE(w));
}

void s_sub(WORD w)
{
	switch(HI_BYTE(w))
	{
	case 0x18:	// SUB.B Rs,Rd	a 18 rs rd
		uasPrintf(".B %s,%s",regByte(nibble(w,2)),regByte(nibble(w,3)) );
		break;
	case 0x19:	// SUB.W Rs,Rd	v 19 rs rd
		uasPrintf(".W %s,%s",regWord(nibble(w,2)),regWord(nibble(w,3)) );
		break;
	case 0x1A:	// SUB.L ERs,ERd	k 1A 1ers 0erd
		if((w & 0x88)!=0x80)s_undef(w);
		else
			uasPrintf(".L %s,%s",regLong(nibble(w,2)),regLong(nibble(w,3)) );
		break;
	case 0x79:	// SUB.W #xx:16,Rd	v 79 3 rd IMM
		ANZ_ASSERT(nibble(w,2)==3);
		uasPrintf(".W #H\'%04X,%s",
			fetchW(),regWord(nibble(w,3)) );
		break;
	case 0x7A:	// SUB.L #xx:32,ERd	k 7A 3 0erd IMM
		ANZ_ASSERT(nibble(w,2)==3);
		if((w & 0x80)!=0)s_undef(w);
		else{
			int wh=fetchW();
			uasPrintf(".L #H\'%04X%04X,%s",
				wh,fetchW(),regLong(nibble(w,3)) );
		}
		break;
	default:
		ANZ_ERROR();
	}
}

void s_bcc(WORD w)
{
	if(nibble(w,0)==4)	// BRA d:8	| 40 disp
		uasPrintf(" #H\'%02X",LO_BYTE(w));
	else if(HI_BYTE(w)==0x58)	// BRA d:16 (BT d:16)	| 58 0 0 disp
	{
		if(nibble(w,3)!=0) s_undef(w);
		else
			uasPrintf(" #H\'%04X",fetchW() );
	}
	else ANZ_ERROR();
}

void s_mdxu(WORD w)
{
	switch(HI_BYTE(w))
	{
	case 0x50:	// MULXU.B Rs,Rd	a 50 rs rd
	case 0x51:	// DIVXU.B Rs,Rd	a 51 rs rd
		uasPrintf(".B %s,%s",regByte(nibble(w,2)),regWord(nibble(w,3)) );
		break;
	case 0x52:	// MULXU.W Rs,ERd	v 52 rs 0erd
	case 0x53:	// DIVXU.W Rs,ERd	v 53 rs 0erd
		if((w & 8)!=0)s_undef(w);
		else
			uasPrintf(".W %s,%s",
				regWord(nibble(w,2)),regLong(nibble(w,3)) );
		break;
	default:
		ANZ_ERROR();
	}
}

void s_rtse(WORD w)	// RTS RTE
{
	// RTS	| 54 70
	// RTE	| 56 70
	if(LO_BYTE(w)!=0x70) s_undef(w);
}

void s_bsr(WORD w)	// BSR
{
	switch(HI_BYTE(w))
	{
	case 0x55:	// BSR d:8	| 55 disp
		uasPrintf(" #H\'%02X",LO_BYTE(w));
		break;
	case 0x5C:	// BSR d:16	| 5C 0 0 disp
		if(LO_BYTE(w)!=0) s_undef(w);
		else
			uasPrintf(" #H\'%04X",fetchW() );
		break;
	default:
		ANZ_ERROR();
	}
}

void s_trapa(WORD w)	// TRAPA
{
	// TRAPA #x:2	| 57 00IMM 0
	if((w & 0xCF)!=0)s_undef(w);
	else
		uasPrintf(" %d",nibble(w,2));
}

void s_jmpsr(WORD w)	// JMP JSR
{
	switch(HI_BYTE(w))
	{
	case 0x59:	// JMP @ERn	| 59 0ern 0
	case 0x5D:	// JSR @ERn	| 5D 0ern 0
		if((w & 0x8F)!=0)s_undef(w);
		else
			uasPrintf(" @%s",regLong(nibble(w,2)) );
		break;
	case 0x5A:	// JMP @aa:24	| 5A abs
	case 0x5E:	// JSR @aa:24	| 5E abs
		uasPrintf(" @H\'%02X%04X",LO_BYTE(w),fetchW() );
		break;
	case 0x5B:	// JMP @@aa:8	| 5B abs
	case 0x5F:	// JSR @@aa:8	| 5F abs
		uasPrintf(" @@H\'%02X",LO_BYTE(w) );
		break;
	default:
		ANZ_ERROR();
	}
}

void B_snct(WORD w)	// BSET,BNOT,BCLR,BTST
{
	switch(HI_BYTE(w))
	{
	case 0x60:	// BSET Rn,Rd	a 60 rn rd
	case 0x61:	// BNOT Rn,Rd	a 61 rn rd
	case 0x62:	// BCLR Rn,Rd	a 62 rn rd
	case 0x63:	// BTST Rn,Rd	a 63 rn rd
		uasPrintf(" %s,%s",regByte(nibble(w,2)),regByte(nibble(w,3)) );
		break;
	case 0x70:	// BSET #xx:3,Rd	a 70 0IMM rd
	case 0x71:	// BNOT #xx:3,Rd	a 71 0IMM rd
	case 0x72:	// BCLR #xx:3,Rd	a 72 0IMM rd
	case 0x73:	// BTST #xx:3,Rd	a 73 0IMM rd
		if((w & 0x80)!=0)s_undef(w);
		else
			uasPrintf(" #\'%d,%s",nibble(w,2),regByte(nibble(w,3)) );
		break;
	default:
		ANZ_ERROR();
	}
}

void s_bsbi(WORD w)	// BST BIST 0x67
{
	if((w & 0x80)==0)	//	BST #xx:3,Rd	a 67 0IMM rd
		uasPrintf("ST");
	else	//	BIST #xx:3,Rd	a 67 1IMM rd
		uasPrintf("IST");
	uasPrintf(" #\'%d,%s",nibble(w,2),regByte(nibble(w,3)) );
}

char *bitOps(int idx)
{
	static char *ops[]={"SET","NOT","CLR","TST","OR","XOR","AND","LD"};
	return ops[idx & 7];
}

void s_boxal(WORD w)	// 0x74,0x75,0x76,0x77
{
	char *op=bitOps(nibble(w,1));
	if((w & 0x80)!=0)uasPrintf("I");
//	BOR #xx:3,Rd	a 74 0IMM rd
//	BIOR #xx:3,Rd	a 74 1IMM rd
//	BXOR #xx:3,Rd	a 75 0IMM rd
//	BIXOR #xx:3,Rd	a 75 1IMM rd
//	BAND #xx:3,Rd	a 76 0IMM rd
//	BIAND #xx:3,Rd	a 76 1IMM rd
//	BLD #xx:3,Rd	a 77 0IMM rd
//	BILD #xx:3,Rd	a 77 1IMM rd
	uasPrintf("%s #\'%d,%s",op,
		nibble(w,2) & 7,regByte(nibble(w,3)) );
}

void s_bsnct(WORD w)	// 0x60,0x61,0x62,0x63,0x70,0x71,0x72,0x73
{
//	char *op=bitOps(nibble(w,1));
	if((w & 0x1000)==0)
// BSET Rn,Rd		a 60 rn rd
// BNOT Rn,Rd		a 61 rn rd
// BCLR Rn,Rd		a 62 rn rd
// BTST Rn,Rd		a 63 rn rd
		uasPrintf(" %s,%s",
			regByte(nibble(w,2)),regByte(nibble(w,3)) );
	else
// BSET #xx:3,Rd	a 70 0IMM rd
// BNOT #xx:3,Rd	a 71 0IMM rd
// BCLR #xx:3,Rd	a 72 0IMM rd
// BTST #xx:3,Rd	a 73 0IMM rd
	{
		int b=nibble(w,2);
		if((b & 8 )!=0){s_undef(w);return;}
		uasPrintf(" #%d,%s",
			b,regByte(nibble(w,3)) );
	}
}



void s_eepmov(WORD w)	// EEPMOV
{
//	EEPMOV.B	| 7B 5C 59	8F
//	EEPMOV.W	| 7B D4 59	8F
	if(LO_BYTE(w)==0x5C){
		w=(WORD)fetchW();
		if(w==0x598F) uasPrintf(".B");
		else{
			s_undef(0x7B5C);
			s_undef(w);
		}
	} if(LO_BYTE(w)==0xD4){
		w=(WORD)fetchW();
		if(w==0x598F) uasPrintf(".W");
		else{
			s_undef(0x7B5C);
			s_undef(w);
		}
	}
}

void s_7Cx(WORD w0)	// 0x7Cxx
{
	char *ereg,*op;
	WORD w1;
	if((w0 & 0x8F)!=0)
	{
		s_undef(w0);
		return;
	}
	w1=(WORD)fetchW();
	if(nibble(w1,3)!=0)
	{
		s_undef(w0);
		s_undef(w1);
		return;
	}
	ereg=regLong(nibble(w0,2));
	op=bitOps(nibble(w1,1));
	switch(HI_BYTE(w1))
	{
	case 0x63:	// BTST Rn,@ERd	a 7C 0erd 0 63 rn 0
		uasPrintf("%s %s,@%s",op,regByte(nibble(w1,2)),ereg);
		break;
	case 0x73:	// BTST #xx:3,@ERd	a 7C 0erd 0 73 0IMM 0
		if((w1 & 0x80)!=0)
		{
			s_undef(w0);
			s_undef(w1);
			return;
		}
		uasPrintf("%s #\'%d,@%s",op,nibble(w1,2) & 7,ereg);
		break;
	case 0x74:	// BOR	 #xx:3,@ERd	a 7C 0erd 0 74 0IMM 0
				// BIOR	 #xx:3,@ERd	a 7C 0erd 0 74 1IMM 0
	case 0x75:	// BXOR	 #xx:3,@ERd	a 7C 0erd 0 75 0IMM 0
				// BIXOR #xx:3,@ERd	a 7C 0erd 0 75 1IMM 0
	case 0x76:	// BAND	 #xx:3,@ERd	a 7C 0erd 0 76	0IMM 0
				// BIAND #xx:3,@ERd	a 7C 0erd 0 76 1IMM 0
	case 0x77:	// BLD	 #xx:3,@ERd	a 7C 0erd 0 77 0IMM 0
				// BILD	 #xx:3,@ERd	a 7C 0erd 0 77 1IMM 0
		if((w1 & 0x80)!=0)uasPrintf("I");
		uasPrintf("%s #\'%d,@%s",op,
			nibble(w1,2) & 7,ereg );
		break;
	default:
		s_undef(w0);
		s_undef(w1);
	}
}

void s_7Dx(WORD w0)
{
	char *ereg;
	WORD w1;
	if((w0 & 0x8F)!=0)
	{
		s_undef(w0);
		return;
	}
	ereg=regLong(nibble(w0,2));
	w1=(WORD)fetchW();
	if(nibble(w1,3)!=0)
	{
		s_undef(w0);
		s_undef(w1);
		return;
	}
	switch(HI_BYTE(w1))
	{
	case 0x60:	// BSET Rn,@ERd	a 7D 0erd 0 60 rn 0
	case 0x61:	// BNOT Rn,@ERd	a 7D 0erd 0 61 rn 0
	case 0x62:	// BCLR Rn,@ERd	a 7D 0erd 0 62 rn 0
		uasPrintf("%s %s,@%s",
			bitOps(nibble(w1,1)),regByte(nibble(w1,2)),ereg);
		break;
	case 0x67:	// BST #xx:3,@ERd	a 7D 0erd 0 67 0IMM 0
				// BIST #xx:3,@ERd	a 7D 0erd 0 67	1IMM 0
		if((w1 & 0x80)!=0)uasPrintf("I");
		uasPrintf("ST #\'%d,@%s",nibble(w1,2) & 7,ereg);
		break;
	case 0x70:	// BSET #xx:3,@ERd	a 7D 0erd 0 70 0IMM 0
	case 0x71:	// BNOT #xx:3,@ERd	a 7D 0erd 0 71 0IMM 0
	case 0x72:	// BCLR #xx:3,@ERd	a 7D 0erd 0 72 0IMM 0
		if((w1 & 0x80)!=0){s_undef(w0);s_undef(w1);}
		else uasPrintf("%s #\'%d,@%s",
			bitOps(nibble(w1,1)),nibble(w1,2),ereg);
		break;
	default:
		s_undef(w0);s_undef(w1);
		break;
	}
}

void s_7Ex(WORD w0)
{
	int abs;
	WORD w1=(WORD)fetchW();
	if(nibble(w1,3)!=0)
	{
		s_undef(w0);
		s_undef(w1);
		return;
	}
	abs=LO_BYTE(w0);
	switch(HI_BYTE(w1))
	{
	case 0x63:	// BTST Rn,@aa:8	a 7E abs 63 rn 0
		uasPrintf("TST %s,@#H\'%02X",regByte(nibble(w1,2)),abs);
		break;
	case 0x73:	// BTST #xx:3,@aa:8	a 7E abs 73 0IMM 0
		if((w1 & 0x80)!=0){s_undef(w0);s_undef(w1);}
		else uasPrintf("TST #\'%d,@#H\'%02X",nibble(w1,2),abs);
		break;
	case 0x74:	// BOR #xx:3,@aa:8	 a 7E abs 74 0IMM 0
				// BIOR #xx:3,@aa:8	 a 7E abs 74 1IMM 0
	case 0x75:	// BXOR #xx:3,@aa:8	 a 7E abs 75 0IMM 0
				// BIXOR #xx:3,@aa:8 a 7E abs 75 1IMM 0
	case 0x76:	// BAND #xx:3,@aa:8	 a 7E abs 76 0IMM 0
				// BIAND #xx:3,@aa:8 a 7E abs 76 1IMM 0
	case 0x77:	// BLD #xx:3,@aa:8	 a 7E abs 77 0IMM 0
				// BILD #xx:3,@aa:8	 a 7E abs 77 1IMM 0
		if((w1 & 0x80)!=0)uasPrintf("I");
		uasPrintf("%s #\'%d,@#H\'%02X",bitOps(nibble(w1,1)),
			nibble(w1,2) & 7,abs );
		break;
	default:
		s_undef(w0);s_undef(w1);
		break;
	}
}

void s_7Fx(WORD w0)
{
	int abs;
	WORD w1=(WORD)fetchW();
	if(nibble(w1,3)!=0)
	{
		s_undef(w0);
		s_undef(w1);
		return;
	}
	abs=LO_BYTE(w0);
	switch(HI_BYTE(w1))
	{
	case 0x60:	// BSET Rn,@aa:8		a 7F abs 60 rn 0
	case 0x61:	// BNOT Rn,@aa:8		a 7F abs 61 rn 0
	case 0x62:	// BCLR Rn,@aa:8		a 7F abs 62 rn 0
		uasPrintf("%s %s,@#H\'%02X",
			bitOps(nibble(w1,1)),regByte(nibble(w1,2)),abs);
		break;
	case 0x70:	// BSET #xx:3,@aa:8	a 7F abs 70 0IMM 0
	case 0x71:	// BNOT #xx:3,@aa:8	a 7F abs 71 0IMM 0
	case 0x72:	// BCLR #xx:3,@aa:8	a 7F abs 72 0IMM 0
		if((w1 & 0x80)!=0){s_undef(w0);s_undef(w1);}
		else uasPrintf("%s #\'%d,@#H\'%02X",
			bitOps(nibble(w1,1)),nibble(w1,2),abs);
		break;
	case 0x67:	// BST #xx:3,@aa:8	a 7F abs 67 0IMM 0
				// BIST #xx:3,@aa:8	a 7F abs 67 1IMM 0
		if((w1 & 0x80)!=0)uasPrintf("I");
		uasPrintf("ST #\'%d,@#H\'%02X",nibble(w1,2) & 7,abs );
		break;
	default:
		s_undef(w0);s_undef(w1);
		break;
	}
}

void s_ldmstm(WORD w0)	// 0x011x 0x012x 0x013x
{
//	LDM.L @SP+,(ERn-ERn+1) k 01 10	6D 7 0ern+1
//	LDM.L @SP+,(ERn-ERn+2) k 01 20	6D 7 0ern+2
//	LDM.L @SP+,(ERn-ERn+3) k 01 30	6D 7 0ern+3
//	STM.L (ERn-ERn+1),@-SP k 01 10 6D F 0ern
//	STM.L (ERn-ERn+2),@-SP k 01 20 6D F 0ern
//	STM.L (ERn-ERn+3),@-SP k 01 30 6D F 0ern

	WORD w1;
	if((w0 & 0x0F)!=0){ s_undef(w0); return; }
	w1=(WORD)fetchW();
	if((w1 & 0xFF78)!=0x6D70)
	{ s_undef(w0); s_undef(w1); return; }
	if((w1 & 0x80)==0)
	uasPrintf("LDM.L @SP+,(ER%d-ER%d)",
		nibble(w1,3)-nibble(w0,2),nibble(w1,3) );
	else
	uasPrintf("STM.L (ER%d-ER%d),@-SP",
		nibble(w1,3),nibble(w0,2)+nibble(w1,3) );
}

void s_ldcstc(WORD w0)	// 0x014x
{
	WORD w1;
	char *ccreg,*ereg;
	if((w0 & 0x0E)!=0 ){s_undef(w0); return; }
	w1=(WORD)fetchW();
	if((w0 & 1)!=0 && (w1 & 0xFC00)==0x0400)
	{	// ORC #xx:8,EXR	a 01 41 04 IMM
		// XORC #xx:8,EXR	a 01 41 05 IMM
		// ANDC #xx:8,EXR	a 01 41 06	IMM
		// LDC #xx:8,EXR	a 01 41 07 IMM
		uasPrintf("%sC #H\'%02X,EXR",
			bitOps( nibble(w1,1)),LO_BYTE(w1) );
		return;
	}
	if((w1 & 0x0F)!=0 ){s_undef(w0);s_undef(w1); return; }
	ccreg=((w0 & 1)==0)? "CCR":"EXR";
	ereg = regLong(nibble(w1,2));
	switch(HI_BYTE(w1))
	{
	case 0x69:
		// LDC @ERs,CCR	v 01 40 69 0ers 0
		// LDC @ERs,EXR	v 01 41 69 0ers 0
		// STC.W CCR,@ERd	v 01 40 69 1erd 0
		// STC.W EXR,@ERd	v 01 41 69 1erd 0
		if((w1 & 0x80)==0)
			uasPrintf("LDC @%s,%s",ereg,ccreg);
		else
			uasPrintf("STC.W %s,@%s",ccreg,ereg);
		break;
	case 0x6B:
		switch(LO_BYTE(w1))
		{
			int wh;
		case 0:
		// LDC @aa:16,CCR		v 01 40 6B 00 abs
		// LDC @aa:16,EXR		v 01 41 6B 00 abs
			uasPrintf("LDC @#H\'%04X,%s",fetchW(),ccreg);
			break;
		case 0x20:
		// LDC @aa:32,CCR		v 01 40 6B 20 abs
		// LDC @aa:32,EXR		v 01 41 6B 20 abs
			wh=fetchW();
			uasPrintf("LDC @#H\'%04X%04X,%s",
				wh,fetchW(),ccreg);
			break;
		case 0x80:
		// STC.W CCR,@aa:16	v 01 40 6B 80 abs
		// STC.W EXR,@aa:16	v 01 41 6B 80 abs
			uasPrintf("STC.W %s,@#H\'%04X",ccreg,fetchW());
			break;
		case 0xA0:
		// STC.W CCR,@aa:32	v 01 40 6B A0 abs
		// STC.W EXR,@aa:32	v 01 41 6B A0 abs
			wh=fetchW();
			uasPrintf("STC.W %s,@#H\'%04X%04X",ccreg,
				wh,fetchW());
			break;
		default:
			s_undef(w0);
			s_undef(w1);
		}
		break;
	case 0x6D:
		// LDC @ERs+,CCR		v 01 40 6D 0ers 0
		// LDC @ERs+,EXR		v 01 41 6D 0ers 0
		// STC.W CCR,@-ERd		v 01 40 6D 1erd 0
		// STC.W EXR,@-ERd		v 01 41 6D 1erd 0
		if((w1 & 0x80)==0)
			uasPrintf("LDC @%s+,%s",ereg,ccreg);
		else
			uasPrintf("STC.W %s,@-%s",ccreg,ereg);
		break;
	case 0x6F:
		// LDC @(d:16,ERs),CCR	 v 01 40 6F 0ers 0 disp
		// LDC @(d:16,ERs),EXR	 v 01 41 6F 0ers 0 disp
		// STC.W CCR,@(d:16,ERd) v 01 40 6F 1erd 0 disp
		// STC.W EXR,@(d:16,ERd) v 01 41 6F 1erd 0 disp
		if((w1 & 0x80)==0)
			uasPrintf("LDC @(#H\'%04X,%s),%s",
				fetchW(),ereg,ccreg);
		else
			uasPrintf("STC.W %s,@(#H\'%04X,%s)",
				ccreg,fetchW(),ereg);
		break;
	case 0x78:
		if((w1 & 0x8F) ==0)
		{
			int wh;
			WORD w2=(WORD)fetchW();
			if(w2 ==0x6B20){
			// LDC @(d:32,ERs),CCR	 v 01 40 78 0ers 0 6B 20 disp
			// LDC @(d:32,ERs),EXR	 v 01 41 78 0ers 0 6B 20 disp
				wh=fetchW();
				uasPrintf("LDC @(#H\'%04X%04X,%s),%s",
					wh,fetchW(),ereg,ccreg);
			}else if(w2 ==0x6BA0){
			// STC.W CCR,@(d:32,ERd) v 01 40 78 0erd 0 6B A0 disp
			// STC.W EXR,@(d:32,ERd) v 01 41 78 0erd 0 6B A0 disp
				wh=fetchW();
				uasPrintf("STC.W %s,@(#H\'%04X%04X,%s)",
					ccreg,wh,fetchW(),ereg);
			}else
			{	s_undef(w0); s_undef(w1); s_undef(w2); }
		}
		else
		{ s_undef(w0); s_undef(w1); }
		break;
	}
}

void s_mac(WORD w0) // 0x16x
{
	// MAC @ERn+,@ERm+	| 01 60 6D 0ern 0erm
	WORD w1;
	if(w0 != 0x160){ s_undef(w0); return;}
	w1=(WORD)fetchW();
	if((w1 & 0xFF88)!=0x6D00){ s_undef(w0);s_undef(w1); return;}
	uasPrintf(" @%s+,@%s+",
		regLong(nibble(w1,2)),regLong(nibble(w1,3)) );
}

void s_sleep(WORD w0) // 0x18x
{
	// SLEEP	| 01 80
	if(w0 != 0x180) s_undef(w0);
}

void s_clrmac(WORD w0)	// 0x01Ax
{
	// CLRMAC	| 01 A0
	if(w0 != 0x1A0) s_undef(w0);
}

void s_01Cx(WORD w0)
{
	// MULXS.B Rs,Rd	a 01 C0 50 rs rd
	// MULXS.W Rs,ERd	v 01 C0 52 rs 0erd
	WORD w1;
	if(w0 != 0x1C0){ s_undef(w0); return; }
	w1=(WORD)fetchW();
	if((w1 & 0xFF00) == 0x5000)
		uasPrintf(".B %s,%s",
			regByte(nibble(w1,2)),regWord(nibble(w1,3)) );
	else if((w1 & 0xFF08) == 0x5200)
		uasPrintf(".W %s,%s",
			regWord(nibble(w1,2)),regLong(nibble(w1,3)) );
	else{ s_undef(w0); s_undef(w1);}
}

void s_01Dx(WORD w0)
{
	// DIVXS.B Rs,Rd	a 01 D0 51 rs rd
	// DIVXS.W Rs,ERd	v 01 D0 53 rs 0erd
	WORD w1;
	if(w0 != 0x1D0){ s_undef(w0); return; }
	w1=(WORD)fetchW();
	if((w1 & 0xFF00) == 0x5100)
		uasPrintf(".B %s,%s",
			regByte(nibble(w1,2)),regWord(nibble(w1,3)) );
	else if((w1 & 0xFF08) == 0x5300)
		uasPrintf(".W %s,%s",
			regWord(nibble(w1,2)),regLong(nibble(w1,3)) );
	else{ s_undef(w0); s_undef(w1);}
}

void s_tas(WORD w0)
{
	// TAS @ERd	a 01 E0 7B 0erd C
	WORD w1;
	if(w0 != 0x1E0){ s_undef(w0); return; }
	w1=(WORD)fetchW();
	if((w1 & 0xFF8F) == 0x7B0C)
		uasPrintf(" @%s",
			regLong(nibble(w1,2)) );
	else{ s_undef(w0); s_undef(w1);}
}

void s_01Fx(WORD w0)
{
	// OR.L ERs,ERd		k 01 F0 64 0ers 0erd
	// XOR.L ERs,ERd	k 01 F0 65 0ers 0erd
	// AND.L ERs,ERd	k 01 F0 66	0ers 0erd
	WORD w1;
	if(w0 != 0x1F0){ s_undef(w0); return; }
	w1=(WORD)fetchW();
	if((w1 & 0xFC88) == 0x6400 && nibble(w1,1)!=7)
		uasPrintf("%s.L %s,%s",	bitOps(nibble(w1,1)),
			regLong(nibble(w1,2)),regLong(nibble(w1,3)) );
	else{ s_undef(w0); s_undef(w1);}
}

void s_inc(WORD w)
{
	// INC.B Rd		a 0A 0 rd
	// INC.W #1,Rd	v 0B 5 rd
	// INC.W #2,Rd	v 0B D rd
	// INC.L #1,ERd	k 0B 7 0erd
	// INC.L #2,ERd	k 0B F 0erd
	if((w & 0xFF80 )==0x0A00)
		uasPrintf(".B %s",regByte(nibble(w,3)) );
	else if((w & 0xFF70 )==0x0B50)
		uasPrintf(".W #%c,%s",((w & 0x80)==0)?'1':'2',regWord(nibble(w,3)) );
	else if((w & 0xFF78 )==0x0B70)
		uasPrintf(".L #%c,%s",((w & 0x80)==0)?'1':'2',regLong(nibble(w,3)) );
	else
		s_undef(w);
}

void s_adds(WORD w)
{
// ADDS #1,ERd	k 0B 0 0erd
// ADDS #2,ERd	k 0B 8 0erd
// ADDS #4,ERd	k 0B 9 0erd
// SUBS #1,ERd	k 1B 0 0erd
// SUBS #2,ERd	k 1B 8 0erd
// SUBS #4,ERd	k 1B 9 0erd
	if((w &8)!=0)s_undef(w);
	else uasPrintf(",%s",regLong(nibble(w,3)) );
}

void s_daa(WORD w)
{
// DAA Rd	a 0F 0 rd
// DAS Rd	a 1F 0 rd
	uasPrintf(" %s",regByte(nibble(w,3)) );
}

void s_shllr(WORD w)	// SHL* ROTX* SHA*
{

// SHLL.B Rd	 a 10 0 rd
// SHLL.B #2,Rd	 a 10 4 rd
// SHLL.W Rd	 v 10 1 rd
// SHLL.W #2,Rd	 v 10 5 rd
// SHLL.L ERd	 k 10 3 0erd
// SHLL.L #2,ERd k 10 7 0erd
// SHLR.B Rd	 a 11 0 rd
// SHLR.B #2,Rd	 a 11 4 rd
// SHLR.W Rd	 v 11 1 rd
// SHLR.W #2,Rd	 v 11 5 rd
// SHLR.L ERd	 k 11 3 0erd
// SHLR.L #2,ERd k 11 7 0erd

// SHAL.B Rd	 a 10 8 rd
// SHAL.B #2,Rd	 a 10 C rd
// SHAL.W Rd	 v 10 9 rd
// SHAL.W #2,Rd	 v 10 D rd
// SHAL.L ERd	 k 10 B 0erd
// SHAL.L #2,ERd k 10 F 0erd
// SHAR.B Rd	 a 11 8 rd
// SHAR.B #2,Rd	 a 11 C rd
// SHAR.W Rd	 v 11 9 rd
// SHAR.W #2,Rd	 v 11 D rd
// SHAR.L ERd	 k 11 B 0erd
// SHAR.L #2,ERd k 11 F 0erd

// ROTXL.B Rd	  a 12	0 rd
// ROTXL.B #2,Rd  a 12	4 rd
// ROTXL.W Rd	  v 12	1 rd
// ROTXL.W #2,Rd  v 12	5 rd
// ROTXL.L ERd	  k 12	3 0erd
// ROTXL.L #2,ERd k 12	7 0erd
// ROTXR.B Rd	  a 13	0 rd
// ROTXR.B #2,Rd  a 13	4 rd
// ROTXR.W Rd	  v 13	1 rd
// ROTXR.W #2,Rd  v 13	5 rd
// ROTXR.L ERd	  k 13	3 0erd
// ROTXR.L #2,ERd k 13	7 0erd

// ROTL.B Rd		a 12	8 rd
// ROTL.B #2,Rd	a 12	C rd
// ROTL.W Rd		v 12	9 rd
// ROTL.W #2,Rd	v 12	D rd
// ROTL.L ERd		k 12	B 0erd
// ROTL.L #2,ERd	k 12	F 0erd
// ROTR.B Rd		a 13	8 rd
// ROTR.B #2,Rd	a 13	C rd
// ROTR.W Rd		v 13	9 rd
// ROTR.W #2,Rd	v 13	D rd
// ROTR.L ERd		k 13	B 0erd
// ROTR.L #2,ERd	k 13	F 0erd

	int bw; char *reg;
	switch(nibble(w,2) & 3)
	{
	case 0: bw='B'; reg=regByte(nibble(w,3)); break;
	case 1: bw='W'; reg=regWord(nibble(w,3)); break;
	case 3:
		if((w & 8)!=0){ s_undef(w); return;}
		bw='L'; reg=regLong(nibble(w,3)); break;
	default: ANZ_ERROR();return;
	}
	uasPrintf(".%c %s%s",bw,((w & 0x40) ==0)?"":"#2,",reg);
}

void s_not(WORD w)
{
// NOT.B Rd		a 17 0 rd
// NOT.W Rd		v 17 1 rd
// NOT.L ERd	k 17 3 0erd
// NEG.B Rd		a 17 8 rd
// NEG.W Rd		v 17 9 rd
// NEG.L ERd	k 17 B 0erd

	int bw; char *reg;
	switch(nibble(w,2) & 3)
	{
	case 0: bw='B'; reg=regByte(nibble(w,3)); break;
	case 1: bw='W'; reg=regWord(nibble(w,3)); break;
	case 3:
		if((w & 8)!=0){ s_undef(w); return;}
		bw='L'; reg=regLong(nibble(w,3)); break;
	default: ANZ_ERROR();return;
	}
	uasPrintf(".%c %s",bw,reg);
}

void s_ext(WORD w)	// 0x17
{
// EXTU.W Rd	v 17 5 rd
// EXTU.L ERd	k 17 7 0erd
// EXTS.W Rd	v 17 D rd
// EXTS.L ERd	k 17 F 0erd
	int bw; char *reg;
	switch(nibble(w,2) & 7)
	{
	case 5: bw='W'; reg=regWord(nibble(w,3)); break;
	case 7:
		if((w & 8)!=0){ s_undef(w); return;}
		bw='L'; reg=regLong(nibble(w,3)); break;
	default: ANZ_ERROR();return;
	}
	uasPrintf(".%c %s",bw,reg);
}


void s_dec(WORD w)
{
// DEC.B Rd		a 1A 0 rd
// DEC.W #1,Rd	v 1B 5 rd
// DEC.W #2,Rd	v 1B D rd
// DEC.L #1,ERd	k 1B 7 0erd
// DEC.L #2,ERd	k 1B F 0erd
	int bw; char *reg,*num;
	switch(nibble(w,2) & 7)
	{
	case 0: bw='B'; num=""; reg=regByte(nibble(w,3)); break;
	case 5: bw='W'; num=((w &0x80)==0)?"#1,":"#2,";
		reg=regWord(nibble(w,3)); break;
	case 7:
		if((w & 8)!=0){ s_undef(w); return;}
		bw='L'; num=((w &0x80)==0)?"#1,":"#2,";
		reg=regLong(nibble(w,3)); break;
	default: ANZ_ERROR();return;
	}
	uasPrintf(".%c %s%s",bw,num,reg);
}


void s_6A1x(WORD w0)
{

	WORD w1,w2; char *op;
	if((w0 & 7)!=0){ s_undef(w0); return; }
	w1=(WORD)fetchW(); w2=(WORD)fetchW();
	if(((w2 & 0xE80F) != 0x6000 && (w2 & 0x108F)!=0) ||
	( HI_BYTE(w2)>0x63 && HI_BYTE(w2)<0x67 ) )
	{
//		printf("[%04X %04X %04X]\n",(int)w0,(int)w1,(int)w2);
		s_undef(w0); s_undef(w1); s_undef(w2);
		return;
	}
	uasPrintf("B");
	op=bitOps(nibble(w2,1));
	if((w2 & 0x400)==0)
	{
// BSET Rn,@aa:16		a 6A 18 abs 60 rn 0
// BSET #xx:3,@aa:16	a 6A 18 abs 70 0IMM 0
// BNOT Rn,@aa:16		a 6A 18 abs 61 rn 0
// BNOT #xx:3,@aa:16	a 6A 18 abs 71 0IMM 0
// BCLR Rn,@aa:16		a 6A 18 abs 62 rn 0
// BCLR #xx:3,@aa:16	a 6A 18 abs 72 0IMM 0
// BTST Rn,@aa:16		a 6A 10 abs 63 rn 0
// BTST #xx:3,@aa:16	a 6A 10 abs 73 0IMM 0
		if((w2 & 0x1000)==0)
			uasPrintf("%s %s,@#H\'%04X",
				op,regByte(nibble(w2,2)),(int)w1);
		else
			uasPrintf("%s #%d,@#H\'%04X",
				op,nibble(w2,2),(int)w1);
	}
//	static char *ops[]={"SET","NOT","CLR","TST","OR","XOR","AND","LD"};
	else
	{
// BST	 #xx:3,@aa:16	a 6A 18 abs 67 0IMM 0
// BIST	 #xx:3,@aa:16	a 6A 18 abs 67 1IMM 0
		if(HI_BYTE(w2)==0x67) op="ST";

// BOR	 #xx:3,@aa:16	a 6A 10 abs 74 0IMM 0
// BIOR	 #xx:3,@aa:16	a 6A 10 abs 74 1IMM 0
// BXOR	 #xx:3,@aa:16	a 6A 10 abs 75 0IMM 0
// BIXOR #xx:3,@aa:16	a 6A 10 abs 75 1IMM 0
// BAND	 #xx:3,@aa:16	a 6A 10 abs 76	0IMM 0
// BIAND #xx:3,@aa:16	a 6A 10 abs 76 1IMM 0
// BLD	 #xx:3,@aa:16	a 6A 10 abs 77 0IMM 0
// BILD	 #xx:3,@aa:16	a 6A 10 abs 77 1IMM 0
		uasPrintf("%s%s #%d,@#H\'%04X",
			((w2 & 0x80)!=0)?"I":"",op,nibble(w2,2)&7,(int)w1);
	}
}


void s_6A3x(WORD w0)
{

	WORD w1,w2,w3; char *op;
	if((w0 & 7) != 0){ s_undef(w0); return; }
	w1=(WORD)fetchW(); w2=(WORD)fetchW(); w3=(WORD)fetchW();
	if(((w3 & 0xE80F) != 0x6000 && (w3 & 0x108F)!=0 )||
	( HI_BYTE(w3)>0x63 && HI_BYTE(w3)<0x67 ) )
	{
		s_undef(w0); s_undef(w1); s_undef(w2); s_undef(w3);
		return;
	}
	uasPrintf("B");
	op=bitOps(nibble(w3,1));
	if((w3 & 0x400)==0 )
	{
// BSET Rn,@aa:32		a 6A 38 abs 60 rn 0
// BSET #xx:3,@aa:32	a 6A 38 abs 70 0IMM 0
// BNOT Rn,@aa:32		a 6A 38 abs 61 rn 0
// BNOT #xx:3,@aa:32	a 6A 38 abs 71 0IMM 0
// BCLR Rn,@aa:32		a 6A 38 abs 62 rn 0
// BCLR #xx:3,@aa:32	a 6A 38 abs 72 0IMM 0
// BTST Rn,@aa:32		a 6A 30 abs 63 rn 0
// BTST #xx:3,@aa:32	a 6A 30 abs 73 0IMM 0
		if((w3 & 0x1000)==0) // 60
			uasPrintf("%s %s,@#H\'%04X%04X",
				op,regByte(nibble(w3,2)),(int)w1,(int)w2 );
		else
			uasPrintf("%s #%d,@#H\'%04X%04X",
				op,nibble(w3,2),(int)w1,(int)w2 );
	}
	else
	{
// BST	#xx:3,@aa:32	a 6A 38 abs 67 0IMM 0
// BIST #xx:3,@aa:32	a 6A 38 abs 67 1IMM 0
		if( HI_BYTE(w3)==0x67) op="ST";

// BOR	 #xx:3,@aa:32	a 6A 30 abs 74 0IMM 0
// BIOR	 #xx:3,@aa:32	a 6A 30 abs 74 1IMM 0
// BXOR	 #xx:3,@aa:32	a 6A 30 abs 75 0IMM 0
// BIXOR #xx:3,@aa:32	a 6A 30 abs 75 1IMM 0
// BAND	 #xx:3,@aa:32	a 6A 30 abs 76	0IMM 0
// BIAND #xx:3,@aa:32	a 6A 30 abs 76 1IMM 0
// BLD	 #xx:3,@aa:32	a 6A 30 abs 77 0IMM 0
// BILD	 #xx:3,@aa:32	a 6A 30 abs 77 1IMM 0
		uasPrintf("%s%s #%d,@#H\'%04X%04X",
			((w3 & 0x80)!=0)?"I":"",op,nibble(w3,2)&7,(int)w1,(int)w2 );
	}
}

void s_movfpe(WORD w0)
{
// MOVFPE @aa:16,Rd		a 6A 4 rd abs
	int w1=fetchW();
	uasPrintf(" @#H\'%04X,%s",w1,regByte(nibble(w0,3)) );
}

void s_movtpe(WORD w0)
{
// MOVTPE Rs,@aa:16		a 6A C rs abs
	int w1=fetchW();
	uasPrintf(" %s,@#H\'%04X",regByte(nibble(w0,3)),w1 );
}


void uas(void)
{
	int n,i;
	WORD w;
	ANALIZETABLE_T *tbl;
	w=(WORD)fetchW();
	tbl = T_x;
	for(i=0;i<3;i++)
	{
		n=nibble(w,i);
		tbl = &tbl[n];
		if( tbl->iname==Spc)
		{
			tbl=(tbl->a_next).tbl;
		}
		else
		{
			uasPrintf(tbl->iname);
			((tbl->a_next).fn)(w);
			uasFlash();
			return;
		}
	}
}

